Description

Several GDAL Modules give me error dialogues while selecting some options. 

MacOSX Mavericks.

The following examples occur while trying to select the output file:

Gdal modules errors

Translate

Traceback (most recent call last):   File

"/Applications/QGIS.app/Contents/MacOS/../Resources/python/plugins/GdalTools/tools/doTranslate.py", line 161, in

fillOutputFileEdit     outputFile = Utils.FileDialog.getSaveFileName(self, self.tr( "Select the raster file to save the results to" ),

Utils.FileFilter.allRastersFilter(), lastUsedFilter )   File

"/Applications/QGIS.app/Contents/MacOS/../Resources/python/plugins/GdalTools/tools/GdalTools_utils.py", line 402, in

getSaveFileName     return self.getDialog(parent, caption, QFileDialog.AcceptSave, QFileDialog.AnyFile, filter, selectedFilter,

useEncoding)   File "/Applications/QGIS.app/Contents/MacOS/../Resources/python/plugins/GdalTools/tools/GdalTools_utils.py",

line 351, in getDialog     dialog.selectNameFilter(selectedFilter[0]) TypeError: QFileDialog.selectNameFilter(QString): argument 1

has unexpected type 'QPyNullVariant'  Python version: 2.7.5 (default, Aug 25 2013, 00:04:04)  [GCC 4.2.1 Compatible Apple LLVM

5.0 (clang-500.0.68)]

Clipper

 Traceback (most recent call last):   File

"/Applications/QGIS.app/Contents/MacOS/../Resources/python/plugins/GdalTools/tools/doClipper.py", line 115, in

fillOutputFileEdit     outputFile = Utils.FileDialog.getSaveFileName(self, self.tr( "Select the raster file to save the results to" ),

Utils.FileFilter.allRastersFilter(), lastUsedFilter)   File

"/Applications/QGIS.app/Contents/MacOS/../Resources/python/plugins/GdalTools/tools/GdalTools_utils.py", line 402, in

getSaveFileName     return self.getDialog(parent, caption, QFileDialog.AcceptSave, QFileDialog.AnyFile, filter, selectedFilter,

useEncoding)   File "/Applications/QGIS.app/Contents/MacOS/../Resources/python/plugins/GdalTools/tools/GdalTools_utils.py",

line 351, in getDialog     dialog.selectNameFilter(selectedFilter[0]) TypeError: QFileDialog.selectNameFilter(QString): argument 1

has unexpected type 'QPyNullVariant'  Python version: 2.7.5 (default, Aug 25 2013, 00:04:04)  [GCC 4.2.1 Compatible Apple LLVM

5.0 (clang-500.0.68)]

Cheers

Associated revisions

Revision 073dbf17 - 2014-03-09 12:56 AM - Larry Shaffer
Fix #9704, GdalTools file dialogs return QPyNullVariant due to QSettings undefined return type

Revision 9c139c28 - 2014-03-10 06:02 PM - Larry Shaffer

Merge pull request #1230 from dakcarto/issue_9704_gdal-qsettings

Fix #9704, GdalTools file dialogs return QPyNullVariant due to QSettings undefined return type

History

#1 - 2014-03-04 12:29 AM - Giovanni Manghi

- Operating System set to OsX

- OS version set to mavericks

did it happened in previous qgis versions?

#2 - 2014-03-04 12:29 AM - Giovanni Manghi

- Status changed from Open to Feedback

#3 - 2014-03-04 03:07 AM - Francesco Vidotto

Same problem here with Mavericks.

It never occurred with previous versions of QGIS

Warp (reproject)

Traceback (most recent call last):

  File "/Applications/QGIS.app/Contents/MacOS/../Resources/python/plugins/GdalTools/tools/doWarp.py", line 129, in fillOutputFileEdit

    outputFile = Utils.FileDialog.getSaveFileName(self, self.tr( "Select the raster file to save the results to" ), Utils.FileFilter.allRastersFilter(),

lastUsedFilter )

  File "/Applications/QGIS.app/Contents/MacOS/../Resources/python/plugins/GdalTools/tools/GdalTools_utils.py", line 402, in getSaveFileName

    return self.getDialog(parent, caption, QFileDialog.AcceptSave, QFileDialog.AnyFile, filter, selectedFilter, useEncoding)

  File "/Applications/QGIS.app/Contents/MacOS/../Resources/python/plugins/GdalTools/tools/GdalTools_utils.py", line 351, in getDialog

    dialog.selectNameFilter(selectedFilter[0])

TypeError: QFileDialog.selectNameFilter(QString): argument 1 has unexpected type 'QPyNullVariant'

Python version:

2.7.5 (default, Aug 25 2013, 00:04:04) 

[GCC 4.2.1 Compatible Apple LLVM 5.0 (clang-500.0.68)]

QGIS version:

2.2.0-Valmiera Valmiera, 

Python path: ['/Applications/QGIS.app/Contents/MacOS/../Resources/python/plugins/processing',

'/Applications/QGIS.app/Contents/MacOS/../Resources/python', u'/Users/vidotto/.qgis2/python', u'/Users/vidotto/.qgis2/python/plugins',

'/Applications/QGIS.app/Contents/MacOS/../Resources/python/plugins', '/Library/Frameworks/SQLite3.framework/Versions/B/Python/2.7',

'/Library/Frameworks/GEOS.framework/Versions/3/Python/2.7', '/Library/Python/2.7/site-packages/numpy-override',

'/Library/Python/2.7/site-packages/matplotlib-override', '/Library/Frameworks/GDAL.framework/Versions/1.10/Python/2.7/site-packages',

'/Library/Python/2.7/site-packages/PySAL-1.7.0-py2.7.egg', '/System/Library/Frameworks/Python.framework/Versions/2.7/lib/python27.zip',

'/System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7',
'/System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/plat-darwin',

'/System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/plat-mac',

'/System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/plat-mac/lib-scriptpackages',

'/System/Library/Frameworks/Python.framework/Versions/2.7/Extras/lib/python',

'/System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/lib-tk',

'/System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/lib-old',

'/System/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/lib-dynload',

'/Users/vidotto/Library/Python/2.7/lib/python/site-packages',

'/System/Library/Frameworks/Python.framework/Versions/2.7/Extras/lib/python/PyObjC', '/Library/Python/2.7/site-packages',

'/Library/Python/2.7/site-packages/PIL', '/Applications/QGIS.app/Contents/Resources/python/plugins/fTools/tools']

Cheers

#4 - 2014-03-04 06:12 AM - Rhenriques Henriques

As Francesco Vidotto said, it was working in previous versions. I do lots of reprojections (warp module) and format transformations. This way I would have

noticed if this was not working in previous versions.

Cheers

#5 - 2014-03-04 06:56 AM - Francesco Vidotto

I have trashed QGIS 2.2 and reinstalled 2.0.1-Dufour (I had to reinstall matplotlib). Now the warp module works like a charm.

#6 - 2014-03-04 08:55 AM - Rhenriques Henriques

Francesco, I have been able to make 2.2 GDAL modules work by pickup the gdal folder from version 2.0.1 located in

"/Applications/QGIS.app/Contents/Resources/python/plugins" (use show package contents over QGIS) and replace by the same folder in 2.2. Of course

that modifications have been made since version 2.0.1 and this is not the most elegant way to make modules work but, by now, all that I need is working.

We can also conclude that the poblem is certainly in the sintax of the newer GDAL .py modules.

Cheers

#7 - 2014-03-04 11:40 PM - Francesco Vidotto

Rhenriques, I tried your method and it works! Many thanks

Cheers

#8 - 2014-03-05 12:37 AM - Giovanni Manghi

- Priority changed from Normal to Severe/Regression

- Subject changed from Gdal Modules Errors to Gdal Modules Errors on OsX Mavericks

- Assignee set to William Kyngesburye

- Target version changed from Version 2.2 to Version 2.4

#9 - 2014-03-05 07:13 AM - William Kyngesburye
Could a problem with preferences from previous version.  Try trashing org.qgis.QGIS2.plist in your home library/preferences (library is hidden, use Finder

Go to folder).  If that doesn't do it, also trash ~/.qgis2 folder (also hidden), or at least all contents of it.

#10 - 2014-03-05 08:39 AM - Francesco Vidotto

William, thanks for your suggestion. Unfortunately this did not solve the problem in my case.

#11 - 2014-03-05 03:03 PM - Rhenriques Henriques

Hi William

As Francesco said, your suggestion did not solve the problem either. I guess that the problem is in the .py modules code. Anyone checked, for

instance,"doWarp.py" line 129?  as the error message warns.

Cheers

#12 - 2014-03-05 04:20 PM - Larry Shaffer

Looks like the return type from QSettings needs to be explicitly defined, to avoid QPyNullVariant from being returned, and that there are incorrect

comparison operators used for comparing None.

I can not reproduce the error here on 10.7.5, but try opening up the GdalTools_utils.py file and change the following:

line ~412: return settings.value( "/GdalTools/" + typeName + "FileFilter", u"" )

to

return settings.value( "/GdalTools/" + typeName + "FileFilter", u"", type=str )  # add ', type=str' 

and replace occurences of:

selectedFilter != None

with (correct None comparison operator)

selectedFilter is not None

It looks like defining the QSettings return type and None comparison need updated across all of GdalTools. I can only surmise that Mac OS X builds using

the latest PyQt4 versions are the first to exhibit the needed changes.

#13 - 2014-03-05 04:28 PM - Larry Shaffer

Hi Giovanni,

A GdalTools update could be pushed out via the official plugin repository channel. So, fixes would not have to wait for QGIS 2.4 release.
The only issue (that may be fixed now) is when QGIS 2.4 comes out, the core GdalTools plugin version number needs to be higher than any delta-update

versions that may be released in between QGIS releases. This would keep the delta-updates of GdalTools plugin, installed in ~/.qgis2/python/plugins, from

being used instead of the new one from core.

I know Victor has done this with Processing plugin a couple of times (at least I'm pretty sure).

#14 - 2014-03-05 04:46 PM - Andrew Mercer

William Kyngesburye wrote:

Could a problem with preferences from previous version.  Try trashing org.qgis.QGIS2.plist in your home library/preferences (library is hidden, use

Finder Go to folder).  If that doesn't do it, also trash ~/.qgis2 folder (also hidden), or at least all contents of it.

This worked for me on OSX 10.7.5 QGIS 2.2.0 doing "Extraction/Clipper" which failed before trashing the plist

#15 - 2014-03-05 09:05 PM - Rhenriques Henriques

Hi William

I just trashed everything that I had before, installed your new compilation 2.2.0-7 but the same problem persists. I don't know if this compilation was meant

to solve also this issue. Got back my backup with the GDAL copied folder trick, which is working. Thanks for the effort anyway. I'll be paying attention to

next compilations.

Cheers

#16 - 2014-03-05 10:28 PM - Larry Shaffer

Rhenriques,

The edit noted above (add ', type=str' for QSettings value read) has reportedly fixed the issue. Please verify, if you have the time.

If this is the proper fix (which I think it is), it may take some time to fix all of GdalTools and get the tested fix into another QGIS 2.2 Mac installer.

#17 - 2014-03-06 03:04 PM - Rhenriques Henriques

- File GdalTools_utils.py added

Hi Larry

In "La Mouche!". The fix solved the issue with the "Save Dialog Box call" in the GDAL modules. I'm uploading the file as a quick fix for MacOSX users. 

Replace the file in "/Applications/QGIS.app/Contents/Resources/python/plugins/GdalTools/tools " with this one. 

William, is it possible to include the modified file into your compilation?

Cheers

#18 - 2014-03-06 04:45 PM - William Kyngesburye
I can drop this into an update.  Make sure to backport to release 2.2 branch in case there is a source update release.

#19 - 2014-03-06 05:39 PM - Larry Shaffer

I can work on this tonight, or tomorrow morning. I noticed several other QSettings reads that need attention in GdalTools. I should make an effort to fix all

of them.

#20 - 2014-03-07 12:51 PM - rcline -

The proposed fix of "selectedFilter is not None" does not fix the problem.

When the program fails, selectedFilter contains this list:  [NULL]

Line 350

if selectedFilter != None:

should be replaced with 

if selectedFilter

0

 != None and selectedFilter

0

 != NULL:

Will it ever contain None?

#21 - 2014-03-07 01:27 PM - Larry Shaffer

rcline - wrote:

The proposed fix of "selectedFilter is not None" does not fix the problem.

That is not the proposed fix. I was merely changing the comparison to the appropriate operator for the None singleton.

The fix is to ensure the returned type from individual QSettings reads are correct, relative to what is expected, as noted above. Otherwise, QPyNullVariant

(NULL in your test) might be returned.

Will it ever contain None?

Actually, it is just a question of whether it is an empty string (after above returned type fix), so simply if selectedFilter should be all that's needed, maybe

with an additional verification that the filter is actually in the available list.

#22 - 2014-03-08 04:06 PM - Larry Shaffer

- Resolution set to fixed/implemented

@rcline I was incorrect. selectedFilter will always be None if the associated keyword arg was undefined (None is its default value). When defined, it

should be a string, regardless of whether that string is empty.

Should be fixed with this pull request. Any testers here please verify the fix by downloading the files from the PR. Works for me here on 10.9.2. If it works

for others, I'll commit to master and 2.2 branches.

Seems there are other core Python plugins that need this fix, e.g. DB Manager.
#23 - 2014-03-08 06:27 PM - Rhenriques Henriques

Hi Larry

Tested after the code changing from https://github.com/qgis/QGIS/pull/1230/files and everything seems to be working just fine. 

Thank you so much.

Cheers

#24 - 2014-03-10 12:38 AM - Francesco Vidotto

Hi Larry, I have made the modifications indicated in https://github.com/qgis/QGIS/pull/1230/files and I confirm that everything seems working correctly on

10.9.2.

Many many thanks

Francesco

#25 - 2014-03-10 10:03 AM - Larry Shaffer

- Status changed from Feedback to Closed

Fixed in changeset commit:"9c139c28fe7d167b16db441a72bcab3c2bc05501".

#26 - 2014-03-10 11:04 AM - Larry Shaffer

Hi,

This has been committed to master branch (2.3), but not to the release-2_2, because there is some question as to whether devs are allowed to commit to

that branch right now.

Files

GdalTools_utils.py 27.9 KB 2014-03-06 Rhenriques Henriques
